//
// Base styles
//

.c-card {
  position: relative;
  display: flex;
  flex-direction: column;
  min-width: 0; // See https://github.com/twbs/bootstrap/pull/22740#issuecomment-305868106
  word-wrap: break-word;
  background-color: $card-bg;
  background-clip: border-box;
  border: $card-border-width solid $card-border-color;
  padding: 25px 40px;
  @include border-radius($card-border-radius);

  >hr {
    margin-right: 0;
    margin-left: 0;
  }

  >.c-list__group:first-child {
    .c-list__group-item:first-child {
      @include border-top-radius($card-border-radius);
    }
  }

  >.c-list__group:last-child {
    .c-list__group-item:last-child {
      @include border-bottom-radius($card-border-radius);
    }
  }
}

.c-card__body {
  // Enable `flex-grow: 1` for decks and groups so that card blocks take up
  // as much space as possible, ensuring footers are aligned to the bottom.
  flex: 1 1 auto;
  padding: $card-spacer-x;
  color: $card-color;
}

.c-card__title {
  margin-bottom: $card-spacer-y;
}

.c-card__subtitle {
  margin-top: -$card-spacer-y / 2;
  margin-bottom: 0;
}

.c-card__text:last-child {
  margin-bottom: 0;
}

.c-card__link {
  @include hover {
    text-decoration: none;
  }

  +.c-card__link {
    margin-left: $card-spacer-x;
  }
}

//
// Optional textual caps
//

.c-card__header {
  padding: $card-spacer-y $card-spacer-x;
  margin-bottom: 0; // Removes the default margin-bottom of <hN>
  color: $card-cap-color;
  background-color: $card-cap-bg;
  border-bottom: $card-border-width solid $card-border-color;
  border-top-left-radius: 10px;
  border-top-right-radius: 10px;

  &:first-child {
    @include border-radius(10px 10px 0 0);
  }

  +.c-list__group {
    .c-list__group-item:first-child {
      border-top: 0;
    }
  }
}

.c-card__footer {
  padding: $card-spacer-y $card-spacer-x;
  background-color: $card-cap-bg;
  border-top: $card-border-width solid $card-border-color;

  &:last-child {
    @include border-radius(0 0 10px 10px);
  }
}


//
// Header navs
//

.c-card__header-tabs {
  margin-right: -$card-spacer-x / 2;
  margin-bottom: -$card-spacer-y;
  margin-left: -$card-spacer-x / 2;
  border-bottom: 0;
}

.c-card__header-pills {
  margin-right: -$card-spacer-x / 2;
  margin-left: -$card-spacer-x / 2;
}

// Card image
.c-card__img-overlay {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  padding: $card-img-overlay-padding;
}

.c-card__img {
  width: 100%; // Required because we use flexbox and this inherently applies align-self: stretch
  @include border-radius($card-inner-border-radius);
}

// Card image caps
.c-card__img-top {
  width: 100%; // Required because we use flexbox and this inherently applies align-self: stretch
  @include border-top-radius($card-inner-border-radius);
}

.c-card__img-bottom {
  width: 100%; // Required because we use flexbox and this inherently applies align-self: stretch
  @include border-bottom-radius($card-inner-border-radius);
}


// Card deck

.c-card__deck {
  display: flex;
  flex-direction: column;

  .c-card {
    margin-bottom: $card-deck-margin;
  }

  @include media-breakpoint-up(sm) {
    flex-flow: row wrap;
    margin-right: -$card-deck-margin;
    margin-left: -$card-deck-margin;

    .c-card {
      display: flex;
      // Flexbugs #4: https://github.com/philipwalton/flexbugs#flexbug-4
      flex: 1 0 0%;
      flex-direction: column;
      margin-right: $card-deck-margin;
      margin-bottom: 0; // Override the default
      margin-left: $card-deck-margin;
    }
  }
}


//
// Card groups
//

.c-card__group {
  display: flex;
  flex-direction: column;

  // The child selector allows nested `.c-card` within `.c-card-group`
  // to display properly.
  >.c-card {
    margin-bottom: $card-group-margin;
  }

  @include media-breakpoint-up(sm) {
    flex-flow: row wrap;

    // The child selector allows nested `.c-card` within `.c-card-group`
    // to display properly.
    >.c-card {
      // Flexbugs #4: https://github.com/philipwalton/flexbugs#flexbug-4
      flex: 1 0 0%;
      margin-bottom: 0;

      +.c-card {
        margin-left: 0;
        border-left: 0;
      }

      // Handle rounded corners
      @if $enable-rounded {
        &:not(:last-child) {
          @include border-right-radius(0);

          .c-card__img-top,
          .c-card__header {
            // stylelint-disable-next-line property-blacklist
            border-top-right-radius: 0;
          }

          .c-card__img-bottom,
          .c-card__footer {
            // stylelint-disable-next-line property-blacklist
            border-bottom-right-radius: 0;
          }
        }

        &:not(:first-child) {
          @include border-left-radius(0);

          .c-card__img-top,
          .c-card__header {
            // stylelint-disable-next-line property-blacklist
            border-top-left-radius: 0;
          }

          .c-card__img-bottom,
          .c-card__footer {
            // stylelint-disable-next-line property-blacklist
            border-bottom-left-radius: 0;
          }
        }
      }
    }
  }
}


//
// Columns
//

.c-card__columns {
  .c-card {
    margin-bottom: $card-columns-margin;
  }

  @include media-breakpoint-up(sm) {
    column-count: $card-columns-count;
    column-gap: $card-columns-gap;
    orphans: 1;
    widows: 1;

    .c-card {
      display: inline-block; // Don't let them vertically span multiple columns
      width: 100%; // Don't let their width change
    }
  }
}


//
// Accordion
//

.c-accordion {
  >.c-card {
    overflow: hidden;

    &:not(:first-of-type) {
      .c-card-header:first-child {
        @include border-radius(0);
      }

      &:not(:last-of-type) {
        border-bottom: 0;
        @include border-radius(0);
      }
    }

    &:first-of-type {
      border-bottom: 0;
      @include border-bottom-radius(0);
    }

    &:last-of-type {
      @include border-top-radius(0);
    }

    .c-card__header {
      margin-bottom: -$card-border-width;
    }
  }
}
